import { MaybeMutable } from '@mutablejs/core';
declare type AllTags = keyof HTMLElementTagNameMap;
declare type MutableObject<Object> = {
    [Key in keyof Object]?: MaybeMutable<Object[Key]>;
};
declare type MutableProps<Tag extends AllTags> = MutableObject<{
    innerHTML: HTMLElementTagNameMap[Tag]['innerHTML'];
    children: HTMLElementTagNameMap[Tag] extends HTMLInputElement ? string : Parameters<HTMLElementTagNameMap[Tag]['replaceChildren']>;
    innerText: string;
    style: string | MutableObject<CSSStyleDeclaration>;
    onclick: HTMLElement['onclick'];
    onchange: HTMLInputElement['onkeyup'];
}>;
export declare function mutableElement<Tag extends AllTags, Props extends MutableProps<Tag>>(tag: Tag, props?: Props): HTMLElementTagNameMap[Tag];
export default mutableElement;
